/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or
 * redistribute the software under the terms of the CeCILL license as
 * circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability. In this
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 12 juil. 2007 07:16:30

import org.cocktail.fwkcktldepense.server.finder.FinderDepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOUtilisateur;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableDictionary;

import er.extensions.eof.ERXEC;

public class FactureListe extends PreCommandeListe {

	private static final long serialVersionUID = 1L;
	private String onloadJS = null;
	private NSArray<NSDictionary<String, Object>> lesFactures = null;
	public NSDictionary<String, Object> uneFacture = null;

	public FactureListe(WOContext context) {
		super(context);
		setDgActif(dgFacture());
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
		if (onloadJS != null)
			onloadJS = null;
	}

	public NSArray<String> itemsMenu() {
		NSArray<String> items = new NSArray<String>(new String[] {
				"Accueil"
		});

		WODisplayGroup dg = dgFacture();
		if (dg != null && dg.allObjects().count() > 0) {
			items = new NSArray<String>(new String[] {
					"ModifierLaRecherche",
					"Accueil"
			});
		}
		return items;
	}

	public WOComponent rechercher() {
		WODisplayGroup dgF = getDg();
		WODisplayGroup dgC = dgCommande();
		dgC.setSelectedObjects(null);
		dgC.setObjectArray(null);
		WODisplayGroup dgE = dgEngagement();
		dgE.setSelectedObjects(null);
		dgE.setObjectArray(null);
		@SuppressWarnings("unchecked")
		NSMutableDictionary<String, Object> bdgs = dgF.queryBindings();

		if (bdgs.objectForKey("exercice") == null) {
			EOExercice exercice = exerciceCourant();
			bdgs.setObjectForKey(exercice, "exercice");
		}
		if (bdgs.objectForKey("utilisateur") == null) {
			EOUtilisateur utilisateur = utilisateurInContext(edc());
			bdgs.setObjectForKey(utilisateur, "utilisateur");
		}
		int nbFactures = FinderDepensePapier.getRawRowCountDepensePapierPourNumeroFacture(edc(), bdgs);
		if (nbFactures > 0 && nbFactures <= 500) {
			lesFactures = FinderDepensePapier.getRawRowDepensePapierPourNumeroFacture(edc(), bdgs);
			session.setAlertMessage(null);
		}
		else {
			lesFactures = null;
			if (nbFactures > 500) {
				session.setAlertMessage(nbFactures + " factures trouvées. Veuillez affiner la recherche.");
			}
			else {
				session.setAlertMessage("Aucune facture trouvée.");
			}
		}
		dgF.setObjectArray(lesFactures);
		dgF.setSelectedObject(null);

		return null;
	}

	public WOComponent detailler() {
		DetailFacture nextPage = null;
		NSDictionary<String, Object> laFacture = getUneFacture();
		EOEditingContext newEdc = ERXEC.newEditingContext();
		NSMutableDictionary<String, Object> bdgs = new NSMutableDictionary<String, Object>();
		bdgs.setObjectForKey(laFacture.objectForKey("CLE"), "cle");
		bdgs.setObjectForKey(utilisateurInContext(newEdc), "utilisateur");
		NSArray<EODepensePapier> lesFactures = FinderDepensePapier.getDepensePapierPourNumeroFacture(newEdc, bdgs);
		EODepensePapier facture = (EODepensePapier) lesFactures.lastObject();
		if (facture != null) {
			nextPage = (DetailFacture) pageWithName("DetailFacture");
			nextPage.setLaFacture(facture);
			session.setLaDepensePapierEnCours(facture);
			session.setLaCommandeEnCours(facture.commandeassociee());
			if (facture.depenseBudgets().count() == 1) {
				session.setLEngagementBudgetEnCours(facture.depenseBudgets().objectAtIndex(0).engagementBudget());
			} else {
				session.setLEngagementBudgetEnCours(null);
			}
		}
		else {
			session.setAlertMessage("Pb d'application: Le détail de cette facture ne peut-être visualisé.");
		}
		return nextPage;
	}

	public String getOnloadJS() {
		return onloadJS;
	}

	public void setOnloadJS(String onloadJS) {
		this.onloadJS = onloadJS;
	}

	@SuppressWarnings("unchecked")
	public NSArray<NSDictionary<String, Object>> getLesFactures() {
		if (lesFactures == null) {
			lesFactures = getDg().allObjects();
		}
		return lesFactures;
	}

	public void setLesFactures(NSArray<NSDictionary<String, Object>> lesFactures) {
		this.lesFactures = lesFactures;
	}

	public NSDictionary<String, Object> getUneFacture() {
		return uneFacture;
	}

	public void setUneFacture(NSDictionary<String, Object> uneFacture) {
		this.uneFacture = uneFacture;
	}

}